#Allow identification of relevant entities
scoreboard players operation @a vsw.id -= @s vsw.id
tag @s add vsw.temp

scoreboard players remove @s[scores={vsw.damage_cooldown=1..}] vsw.damage_cooldown 1

#Lightsaber spin animation
tp @s ~ ~ ~ ~45 ~

#Keeps track of lightsaber travel distance and stage
scoreboard players add @s vsw.tick_timer 1

#Initiate subtick loop
scoreboard players set @s vsw.subtick_timer 0
execute if score @s vsw.tick_timer matches 1..12 on passengers rotated as @s on vehicle positioned ^ ^ ^.1 run function vsw:lightsaber/thrown/entity_subtick/depart
execute if score @s vsw.tick_timer matches 13.. positioned ~ ~.0625 ~ facing entity @a[scores={vsw.id=0},limit=1] eyes positioned ~ ~-.0625 ~ positioned ^ ^ ^.1 run function vsw:lightsaber/thrown/entity_subtick/return

#Prevents lightsaber hit sound and particles from playing more than once a tick
execute at @s[tag=vsw.hit_entity] run playsound vsw:item.lightsaber.hit neutral @a ~ ~ ~
tag @s remove vsw.hit_entity
execute at @s[tag=vsw.in_water] run particle minecraft:bubble ~ ~ ~ 0.3 0 0.3 0 1
tag @s remove vsw.in_water

execute unless entity @e[type=player,scores={vsw.id=0},gamemode=!spectator] run function vsw:lightsaber/thrown/lost_owner with entity @s

#Remove identification modifications
scoreboard players operation @a vsw.id += @s vsw.id
tag @s remove vsw.temp

#Kill lightsaber at the end of throw
execute if entity @s[tag=vsw.end] on passengers run kill @s
execute if entity @s[tag=vsw.end] run kill @s